#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include <simics/magic-instruction.h>

typedef double real;

/* Column-major matrices */
#define A(row,column) _A[(row) + ldA*(column)]
#define B(row,column) _B[(row) + ldB*(column)]
#define C(row,column) _C[(row) + ldC*(column)]

#define ARRAY_SIZE 262144
#define SQ_DIM_SIZE 512

void
gemm(int M, int N, int K, 
	 real alpha, real* _A, int ldA, real* _B, int ldB,
	 real beta, real* _C, int ldC)
{
	int m, n, k;
	for(n = 0; n < N; n++)
		for(m = 0; m < M; m++)
		{
			real C_mn = beta * C(m,n);
			for(k = 0; k < K; k++)
				C_mn += alpha*A(m,k)*B(k,n);
			C(m,n) = C_mn;
		}
}


int main(int argc, char* argv[]){

	real _A[ARRAY_SIZE];
	real _B[ARRAY_SIZE];
	real _C[ARRAY_SIZE] = {0};

	real alpha = 1;
	real beta = 1;

	int ldA = SQ_DIM_SIZE;
	int ldB = SQ_DIM_SIZE;
	int ldC = SQ_DIM_SIZE;

	int M = SQ_DIM_SIZE;
	int N = SQ_DIM_SIZE;
	int K = SQ_DIM_SIZE;
	
	int i = 0;

	//fill arrays
	for(i = 0; i < ARRAY_SIZE; i++){
		_A[i] = rand();
		_B[i] = rand();
	}

	MAGIC_BREAKPOINT;

	//for(i = 0; i < trials; i++)
	gemm(M, N, K, alpha, _A, ldA, _B, ldB, beta, _C, ldC);

	MAGIC_BREAKPOINT;
}

